import tkinter
from tkinter import ttk
import logging
import jtk
import random
           
class Mux:
    def __init__(self, canvas, x, y):
        parent = canvas.master
        width = 50
        height = 300
        r = canvas.create_rectangle(x, y, x+width, y+height,
                                    fill='white', outline='black')
        canvas.create_text(x+width/2, y+height/3, anchor="e", text="0") ## label        
        canvas.create_text(x+width/2, y+2*height/3, anchor="e", text="1") ## label        
        self.op = ttk.Combobox(parent, width=3, values=['0', '1'],
                                state='readonly', takefocus=False)
        self.op.bind("<<ComboboxSelected>>", parent.doOp)
        self.op.set('0')
        jtk.TextLine(canvas, x+width/2, y+height, x+width/2, y+height+50, 4,
                                        "n", self.op, 40)
        
##        self.cb = ttk.Checkbutton(parent, text="#", command=self.checked)
##        self.cb.state(['selected', "!alternate"])

if __name__ == "__main__":

    TopLeft_X = 175
    TopLeft_Y = 100

    class App(ttk.Frame):
        def __init__(self, parent):
            super().__init__(parent)
            logging.basicConfig(level=logging.INFO)
            self.win = win = tkinter.Canvas(self, width=400, height=500)
            win.pack()
            self.a = Mux(win, TopLeft_X, TopLeft_Y)
            
            self.xval = jtk.RTVEntry(self, self.resultOK, self.doBad,
                        width=25, justify="center")
            self.xval.insert(0, str(random.randint(1,999)))
            jtk.TextLine(win, 125, 200, 175, 200, 10, "e", self.xval, 40)
            
            self.yval = jtk.RTVEntry(self, self.resultOK, self.doBad,
                        width=25, justify="center")
            self.yval.insert(0, str(random.randint(1,999)))
            jtk.TextLine(win, 125, 300, 175, 300, 10, "e", self.yval, 40)
            
            self.zval = ttk.Label(win, text="0")
            zwire = jtk.TextLine(win, 225, 250, 275, 250, 10, "w", self.zval, 40)
            
        def resultOK(self, string, dummy):
            if string == '':
                retval = True, '0', 1                 ## third value positions cursor
            else:
                try:
                    result = int(string)
                except:
                    return False, None                ## no change, so bail out now
                else:
                    retval = -1000 <= result <= 1000, self.trim(string)
            self.after(0, self.doOp)
            return retval

        def trim(self, string):  ## get rid of leading zeroes but not entire string
                i = 0
                for i in range(len(string) - 1):
                    if string[i] != '0': break
                    i += 1
                return string[i:]

        def doOp(self, evt=None):
            x = self.xval.get()
            x = int(x)
            y = self.yval.get()
            y = int(y)
            op = self.a.op.get()
            if op == "0":
                z = x
            elif op == "1":
                z = y
            logging.info("z is {}; str(z) is '{}'".format(z, str(z)))
            self.zval['text'] = str(z)
            
        def doBad(self):
            self.bell()
        
    def main():
        root = tkinter.Tk()
        root.title("Model Multiplexor")
        a = App(root)
        a.pack()
        root.mainloop()

    main()
